' GetCacheFile.VBS V1.00 (C) yoshioka.teruo@nifty.com 2006-06-11
' GetCacheFile.VBS gets cache file from URL.
' Usage: Start GetCacheFile.VBS URL [filename]

Option Explicit
Const adSaveCreateNotExist=1
Const adSaveCreateOverWrite=2 
Dim URL
Dim Path
Dim Stream

If WScript.Arguments.Count=0 Then
  URL=InputBox("Enter URL",WScript.ScriptName)
Else
  URL=WScript.Arguments.Item(0)
End If
If URL="" Or WScript.Arguments.Count>2 Then
  WScript.Echo "Usage: GetCacheFile.VBS URL [filename]"
  WScript.Quit
End If
If WScript.Arguments.Count=2 Then
  Path=WScript.Arguments.Item(1)
Else
  Path=Replace(Replace(Replace(Replace(URL,":","_"),"/","_"),"\","_"),"?","_")
  Path=Left(Replace(Path,"%20"," "),125)
  Path=FileSaveAs(Path)
  If Path="" Then WScript.Quit
End If

Set Stream=GetCacheFile(URL)
If Stream Is Nothing Then
  WScript.Echo "w肳ꂽ\[X͌܂B" & vbLf & URL
Else
  Stream.SaveToFile Path,adSaveCreateOverWrite 
End If
WScript.Quit

Function GetCacheFile(URL)
Const Key="HKCU\Software\Microsoft\Windows\CurrentVersion\Internet Settings\GlobalUserOffline" 
Dim wShell
Dim Offline
Dim CDOMessage
Dim BodyPart

Set wShell=CreateObject("WScript.Shell") 
Offline=wShell.RegRead(Key) 
If Offline=0 Then wShell.RegWrite Key,1,"REG_DWORD" 
Set CDOMessage=CreateObject("CDO.Message") 
'Function AddAttachment(URL As String, [UserName As String], [Password As String]) As IBodyPart
'    Adds an attachment (BodyPart) to the message
On Error Resume Next
Set BodyPart=CDOMessage.AddAttachment(URL)
On Error GoTo 0
If Offline=0 Then wShell.RegWrite Key,0,"REG_DWORD" 
If IsEmpty(BodyPart) Then
  Set GetCacheFile=Nothing
Else
  Set GetCacheFile=BodyPart.GetDecodedContentStream()
End If
End Function

Function FileSaveAs(Path)
Dim FileSaveDlg
On Error Resume Next
Set FileSaveDlg=CreateObject("SAFRCFileDlg.FileSave") 
On Error GoTo 0
If IsEmpty(FileSaveDlg) Then
  FileSaveAs=Path
  Exit Function
End If
FileSaveDlg.FileName=Path
FileSaveDlg.FileType="ׂẴt@C(*.*)" 
If FileSaveDlg.OpenFileSaveDlg() Then FileSaveAs=FileSaveDlg.FileName 
End Function
